Index: sasmodels/compare.py
===================================================================
--- sasmodels/compare.py	(revision 2a7e20e9c4ba72da5c6088e743a64f3345ee554d)
+++ sasmodels/compare.py	(revision 1fbadb20289a15dcd2b077eb8ef47e0dbda5eef1)
@@ -40,4 +40,5 @@
 from . import core
 from . import kerneldll
+from . import kernelcl
 from .data import plot_theory, empty_data1D, empty_data2D, load_data
 from .direct_model import DirectModel, get_mesh
@@ -623,4 +624,51 @@
 
 
+def time_calculation(calculator, pars, evals=1):
+    # type: (Calculator, ParameterSet, int) -> Tuple[np.ndarray, float]
+    """
+    Compute the average calculation time over N evaluations.
+
+    An additional call is generated without polydispersity in order to
+    initialize the calculation engine, and make the average more stable.
+    """
+    # initialize the code so time is more accurate
+    if evals > 1:
+        calculator(**suppress_pd(pars))
+    toc = tic()
+    # make sure there is at least one eval
+    value = calculator(**pars)
+    for _ in range(evals-1):
+        value = calculator(**pars)
+    average_time = toc()*1000. / evals
+    #print("I(q)",value)
+    return value, average_time
+
+def make_data(opts):
+    # type: (Dict[str, Any]) -> Tuple[Data, np.ndarray]
+    """
+    Generate an empty dataset, used with the model to set Q points
+    and resolution.
+
+    *opts* contains the options, with 'qmax', 'nq', 'res',
+    'accuracy', 'is2d' and 'view' parsed from the command line.
+    """
+    qmin, qmax, nq, res = opts['qmin'], opts['qmax'], opts['nq'], opts['res']
+    if opts['is2d']:
+        q = np.linspace(-qmax, qmax, nq)  # type: np.ndarray
+        data = empty_data2D(q, resolution=res)
+        data.accuracy = opts['accuracy']
+        set_beam_stop(data, qmin)
+        index = ~data.mask
+    else:
+        if opts['view'] == 'log' and not opts['zero']:
+            q = np.logspace(math.log10(qmin), math.log10(qmax), nq)
+        else:
+            q = np.linspace(qmin, qmax, nq)
+        if opts['zero']:
+            q = np.hstack((0, q))
+        data = empty_data1D(q, resolution=res)
+        index = slice(None, None)
+    return data, index
+
 DTYPE_MAP = {
     'half': '16',
@@ -643,10 +691,4 @@
     Return a model calculator using the OpenCL calculation engine.
     """
-    if not core.HAVE_OPENCL:
-        raise RuntimeError("OpenCL not available")
-    model = core.build_model(model_info, dtype=dtype, platform="ocl")
-    calculator = DirectModel(data, model, cutoff=cutoff)
-    calculator.engine = "OCL%s"%DTYPE_MAP[str(model.dtype)]
-    return calculator
 
 def eval_ctypes(model_info, data, dtype='double', cutoff=0.):
@@ -660,51 +702,4 @@
     return calculator
 
-def time_calculation(calculator, pars, evals=1):
-    # type: (Calculator, ParameterSet, int) -> Tuple[np.ndarray, float]
-    """
-    Compute the average calculation time over N evaluations.
-
-    An additional call is generated without polydispersity in order to
-    initialize the calculation engine, and make the average more stable.
-    """
-    # initialize the code so time is more accurate
-    if evals > 1:
-        calculator(**suppress_pd(pars))
-    toc = tic()
-    # make sure there is at least one eval
-    value = calculator(**pars)
-    for _ in range(evals-1):
-        value = calculator(**pars)
-    average_time = toc()*1000. / evals
-    #print("I(q)",value)
-    return value, average_time
-
-def make_data(opts):
-    # type: (Dict[str, Any]) -> Tuple[Data, np.ndarray]
-    """
-    Generate an empty dataset, used with the model to set Q points
-    and resolution.
-
-    *opts* contains the options, with 'qmax', 'nq', 'res',
-    'accuracy', 'is2d' and 'view' parsed from the command line.
-    """
-    qmin, qmax, nq, res = opts['qmin'], opts['qmax'], opts['nq'], opts['res']
-    if opts['is2d']:
-        q = np.linspace(-qmax, qmax, nq)  # type: np.ndarray
-        data = empty_data2D(q, resolution=res)
-        data.accuracy = opts['accuracy']
-        set_beam_stop(data, qmin)
-        index = ~data.mask
-    else:
-        if opts['view'] == 'log' and not opts['zero']:
-            q = np.logspace(math.log10(qmin), math.log10(qmax), nq)
-        else:
-            q = np.linspace(qmin, qmax, nq)
-        if opts['zero']:
-            q = np.hstack((0, q))
-        data = empty_data1D(q, resolution=res)
-        index = slice(None, None)
-    return data, index
-
 def make_engine(model_info, data, dtype, cutoff, ngauss=0):
     # type: (ModelInfo, Data, str, float) -> Calculator
@@ -718,8 +713,14 @@
         set_integration_size(model_info, ngauss)
 
-    if dtype is None or not dtype.endswith('!'):
-        return eval_opencl(model_info, data, dtype=dtype, cutoff=cutoff)
-    else:
-        return eval_ctypes(model_info, data, dtype=dtype[:-1], cutoff=cutoff)
+    if dtype != "default" and not dtype.endswith('!') and not kernelcl.use_opencl():
+        raise RuntimeError("OpenCL not available " + kernelcl.OPENCL_ERROR)
+
+    model = core.build_model(model_info, dtype=dtype, platform="ocl")
+    calculator = DirectModel(data, model, cutoff=cutoff)
+    engine_type = calculator._model.__class__.__name__.replace('Model', '').upper()
+    bits = calculator._model.dtype.itemsize*8
+    precision = "fast" if getattr(calculator._model, 'fast', False) else str(bits)
+    calculator.engine = "%s[%s]" % (engine_type, precision)
+    return calculator
 
 def _show_invalid(data, theory):
@@ -751,8 +752,8 @@
     """
     for k in range(opts['sets']):
-        if k > 1:
+        if k > 0:
             # print a separate seed for each dataset for better reproducibility
             new_seed = np.random.randint(1000000)
-            print("Set %d uses -random=%i"%(k+1, new_seed))
+            print("=== Set %d uses -random=%i ==="%(k+1, new_seed))
             np.random.seed(new_seed)
         opts['pars'] = parse_pars(opts, maxdim=maxdim)
@@ -761,4 +762,7 @@
         result = run_models(opts, verbose=True)
         if opts['plot']:
+            if opts['is2d'] and k > 0:
+                import matplotlib.pyplot as plt
+                plt.figure()
             limits = plot_models(opts, result, limits=limits, setnum=k)
         if opts['show_weights']:
@@ -1328,16 +1332,19 @@
 
     # Evaluate preset parameter expressions
+    # Note: need to replace ':' with '_' in parameter names and expressions
+    # in order to support math on magnetic parameters.
     context = MATH.copy()
     context['np'] = np
-    context.update(pars)
+    context.update((k.replace(':', '_'), v) for k, v in pars.items())
     context.update((k, v) for k, v in presets.items() if isinstance(v, float))
+    #for k,v in sorted(context.items()): print(k, v)
     for k, v in presets.items():
         if not isinstance(v, float) and not k.endswith('_type'):
-            presets[k] = eval(v, context)
+            presets[k] = eval(v.replace(':', '_'), context)
     context.update(presets)
-    context.update((k, v) for k, v in presets2.items() if isinstance(v, float))
+    context.update((k.replace(':', '_'), v) for k, v in presets2.items() if isinstance(v, float))
     for k, v in presets2.items():
         if not isinstance(v, float) and not k.endswith('_type'):
-            presets2[k] = eval(v, context)
+            presets2[k] = eval(v.replace(':', '_'), context)
 
     # update parameters with presets
@@ -1369,5 +1376,5 @@
     path = os.path.dirname(info.filename)
     url = "file://" + path.replace("\\", "/")[2:] + "/"
-    rst2html.view_html_qtapp(html, url)
+    rst2html.view_html_wxapp(html, url)
 
 def explore(opts):
@@ -1490,5 +1497,6 @@
             vmin, vmax = limits
             self.limits = vmax*1e-7, 1.3*vmax
-            import pylab; pylab.clf()
+            import pylab
+            pylab.clf()
             plot_models(self.opts, result, limits=self.limits)
 
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/convert.py	(revision a69d8cd7ece8a1df933b123d2e032197783d80b4)
@@ -633,6 +633,5 @@
 def test_backward_forward():
     from .core import list_models
+    L = lambda name: _check_one(name, seed=1)
     for name in list_models('all'):
-        L = lambda: _check_one(name, seed=1)
-        L.description = name
-        yield L
+        yield L, name
Index: sasmodels/core.py
===================================================================
--- sasmodels/core.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/core.py	(revision 3221de0ed9b3480163246ceb0503432126bd5134)
@@ -21,21 +21,7 @@
 from . import mixture
 from . import kernelpy
+from . import kernelcl
 from . import kerneldll
 from . import custom
-
-if os.environ.get("SAS_OPENCL", "").lower() == "none":
-    HAVE_OPENCL = False
-else:
-    try:
-        from . import kernelcl
-        HAVE_OPENCL = True
-    except Exception:
-        HAVE_OPENCL = False
-
-CUSTOM_MODEL_PATH = os.environ.get('SAS_MODELPATH', "")
-if CUSTOM_MODEL_PATH == "":
-    CUSTOM_MODEL_PATH = joinpath(os.path.expanduser("~"), ".sasmodels", "custom_models")
-    if not os.path.isdir(CUSTOM_MODEL_PATH):
-        os.makedirs(CUSTOM_MODEL_PATH)
 
 # pylint: disable=unused-import
@@ -47,4 +33,10 @@
     pass
 # pylint: enable=unused-import
+
+CUSTOM_MODEL_PATH = os.environ.get('SAS_MODELPATH', "")
+if CUSTOM_MODEL_PATH == "":
+    CUSTOM_MODEL_PATH = joinpath(os.path.expanduser("~"), ".sasmodels", "custom_models")
+    if not os.path.isdir(CUSTOM_MODEL_PATH):
+        os.makedirs(CUSTOM_MODEL_PATH)
 
 # TODO: refactor composite model support
@@ -148,47 +140,31 @@
     used with functions in generate to build the docs or extract model info.
     """
-    if '@' in model_string:
-        parts = model_string.split('@')
-        if len(parts) != 2:
-            raise ValueError("Use P@S to apply a structure factor S to model P")
-        P_info, Q_info = [load_model_info(part) for part in parts]
-        return product.make_product_info(P_info, Q_info)
-
-    product_parts = []
-    addition_parts = []
-
-    addition_parts_names = model_string.split('+')
-    if len(addition_parts_names) >= 2:
-        addition_parts = [load_model_info(part) for part in addition_parts_names]
-    elif len(addition_parts_names) == 1:
-        product_parts_names = model_string.split('*')
-        if len(product_parts_names) >= 2:
-            product_parts = [load_model_info(part) for part in product_parts_names]
-        elif len(product_parts_names) == 1:
-            if "custom." in product_parts_names[0]:
-                # Extract ModelName from "custom.ModelName"
-                pattern = "custom.([A-Za-z0-9_-]+)"
-                result = re.match(pattern, product_parts_names[0])
-                if result is None:
-                    raise ValueError("Model name in invalid format: " + product_parts_names[0])
-                model_name = result.group(1)
-                # Use ModelName to find the path to the custom model file
-                model_path = joinpath(CUSTOM_MODEL_PATH, model_name + ".py")
-                if not os.path.isfile(model_path):
-                    raise ValueError("The model file {} doesn't exist".format(model_path))
-                kernel_module = custom.load_custom_kernel_module(model_path)
-                return modelinfo.make_model_info(kernel_module)
-            # Model is a core model
-            kernel_module = generate.load_kernel_module(product_parts_names[0])
-            return modelinfo.make_model_info(kernel_module)
-
-    model = None
-    if len(product_parts) > 1:
-        model = mixture.make_mixture_info(product_parts, operation='*')
-    if len(addition_parts) > 1:
-        if model is not None:
-            addition_parts.append(model)
-        model = mixture.make_mixture_info(addition_parts, operation='+')
-    return model
+    if "+" in model_string:
+        parts = [load_model_info(part)
+                 for part in model_string.split("+")]
+        return mixture.make_mixture_info(parts, operation='+')
+    elif "*" in model_string:
+        parts = [load_model_info(part)
+                 for part in model_string.split("*")]
+        return mixture.make_mixture_info(parts, operation='*')
+    elif "@" in model_string:
+        p_info, q_info = [load_model_info(part)
+                          for part in model_string.split("@")]
+        return product.make_product_info(p_info, q_info)
+    # We are now dealing with a pure model
+    elif "custom." in model_string:
+        pattern = "custom.([A-Za-z0-9_-]+)"
+        result = re.match(pattern, model_string)
+        if result is None:
+            raise ValueError("Model name in invalid format: " + model_string)
+        model_name = result.group(1)
+        # Use ModelName to find the path to the custom model file
+        model_path = joinpath(CUSTOM_MODEL_PATH, model_name + ".py")
+        if not os.path.isfile(model_path):
+            raise ValueError("The model file {} doesn't exist".format(model_path))
+        kernel_module = custom.load_custom_kernel_module(model_path)
+        return modelinfo.make_model_info(kernel_module)
+    kernel_module = generate.load_kernel_module(model_string)
+    return modelinfo.make_model_info(kernel_module)
 
 
@@ -292,5 +268,5 @@
     if platform is None:
         platform = "ocl"
-    if platform == "ocl" and not HAVE_OPENCL or not model_info.opencl:
+    if not kernelcl.use_opencl() or not model_info.opencl:
         platform = "dll"
 
@@ -336,4 +312,61 @@
     print("\n".join(list_models(kind)))
 
+def test_composite_order():
+    def test_models(fst, snd):
+        """Confirm that two models produce the same parameters"""
+        fst = load_model(fst)
+        snd = load_model(snd)
+        # Un-disambiguate parameter names so that we can check if the same
+        # parameters are in a pair of composite models. Since each parameter in
+        # the mixture model is tagged as e.g., A_sld, we ought to use a
+        # regex subsitution s/^[A-Z]+_/_/, but removing all uppercase letters
+        # is good enough.
+        fst = [[x for x in p.name if x == x.lower()] for p in fst.info.parameters.kernel_parameters]
+        snd = [[x for x in p.name if x == x.lower()] for p in snd.info.parameters.kernel_parameters]
+        assert sorted(fst) == sorted(snd), "{} != {}".format(fst, snd)
+
+    def build_test(first, second):
+        test = lambda description: test_models(first, second)
+        description = first + " vs. " + second
+        return test, description
+
+    yield build_test(
+        "cylinder+sphere",
+        "sphere+cylinder")
+    yield build_test(
+        "cylinder*sphere",
+        "sphere*cylinder")
+    yield build_test(
+        "cylinder@hardsphere*sphere",
+        "sphere*cylinder@hardsphere")
+    yield build_test(
+        "barbell+sphere*cylinder@hardsphere",
+        "sphere*cylinder@hardsphere+barbell")
+    yield build_test(
+        "barbell+cylinder@hardsphere*sphere",
+        "cylinder@hardsphere*sphere+barbell")
+    yield build_test(
+        "barbell+sphere*cylinder@hardsphere",
+        "barbell+cylinder@hardsphere*sphere")
+    yield build_test(
+        "sphere*cylinder@hardsphere+barbell",
+        "cylinder@hardsphere*sphere+barbell")
+    yield build_test(
+        "barbell+sphere*cylinder@hardsphere",
+        "cylinder@hardsphere*sphere+barbell")
+    yield build_test(
+        "barbell+cylinder@hardsphere*sphere",
+        "sphere*cylinder@hardsphere+barbell")
+
+def test_composite():
+    # type: () -> None
+    """Check that model load works"""
+    #Test the the model produces the parameters that we would expect
+    model = load_model("cylinder@hardsphere*sphere")
+    actual = [p.name for p in model.info.parameters.kernel_parameters]
+    target = ("sld sld_solvent radius length theta phi volfraction"
+              " A_sld A_sld_solvent A_radius").split()
+    assert target == actual, "%s != %s"%(target, actual)
+
 if __name__ == "__main__":
     list_models_main()
Index: sasmodels/data.py
===================================================================
--- sasmodels/data.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/data.py	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -706,5 +706,7 @@
     else:
         vmin_scaled, vmax_scaled = vmin, vmax
-    plt.imshow(plottable.reshape(len(data.x_bins), len(data.y_bins)),
+    #nx, ny = len(data.x_bins), len(data.y_bins)
+    x_bins, y_bins, image = _build_matrix(data, plottable)
+    plt.imshow(image,
                interpolation='nearest', aspect=1, origin='lower',
                extent=[xmin, xmax, ymin, ymax],
@@ -714,4 +716,174 @@
     return vmin, vmax
 
+
+# === The following is modified from sas.sasgui.plottools.PlotPanel
+def _build_matrix(self, plottable):
+    """
+    Build a matrix for 2d plot from a vector
+    Returns a matrix (image) with ~ square binning
+    Requirement: need 1d array formats of
+    self.data, self.qx_data, and self.qy_data
+    where each one corresponds to z, x, or y axis values
+
+    """
+    # No qx or qy given in a vector format
+    if self.qx_data is None or self.qy_data is None \
+            or self.qx_data.ndim != 1 or self.qy_data.ndim != 1:
+        return self.x_bins, self.y_bins, plottable
+
+    # maximum # of loops to fillup_pixels
+    # otherwise, loop could never stop depending on data
+    max_loop = 1
+    # get the x and y_bin arrays.
+    x_bins, y_bins = _get_bins(self)
+    # set zero to None
+
+    #Note: Can not use scipy.interpolate.Rbf:
+    # 'cause too many data points (>10000)<=JHC.
+    # 1d array to use for weighting the data point averaging
+    #when they fall into a same bin.
+    weights_data = np.ones([self.data.size])
+    # get histogram of ones w/len(data); this will provide
+    #the weights of data on each bins
+    weights, xedges, yedges = np.histogram2d(x=self.qy_data,
+                                             y=self.qx_data,
+                                             bins=[y_bins, x_bins],
+                                             weights=weights_data)
+    # get histogram of data, all points into a bin in a way of summing
+    image, xedges, yedges = np.histogram2d(x=self.qy_data,
+                                           y=self.qx_data,
+                                           bins=[y_bins, x_bins],
+                                           weights=plottable)
+    # Now, normalize the image by weights only for weights>1:
+    # If weight == 1, there is only one data point in the bin so
+    # that no normalization is required.
+    image[weights > 1] = image[weights > 1] / weights[weights > 1]
+    # Set image bins w/o a data point (weight==0) as None (was set to zero
+    # by histogram2d.)
+    image[weights == 0] = None
+
+    # Fill empty bins with 8 nearest neighbors only when at least
+    #one None point exists
+    loop = 0
+
+    # do while loop until all vacant bins are filled up up
+    #to loop = max_loop
+    while (weights == 0).any():
+        if loop >= max_loop:  # this protects never-ending loop
+            break
+        image = _fillup_pixels(image=image, weights=weights)
+        loop += 1
+
+    return x_bins, y_bins, image
+
+def _get_bins(self):
+    """
+    get bins
+    set x_bins and y_bins into self, 1d arrays of the index with
+    ~ square binning
+    Requirement: need 1d array formats of
+    self.qx_data, and self.qy_data
+    where each one corresponds to  x, or y axis values
+    """
+    # find max and min values of qx and qy
+    xmax = self.qx_data.max()
+    xmin = self.qx_data.min()
+    ymax = self.qy_data.max()
+    ymin = self.qy_data.min()
+
+    # calculate the range of qx and qy: this way, it is a little
+    # more independent
+    x_size = xmax - xmin
+    y_size = ymax - ymin
+
+    # estimate the # of pixels on each axes
+    npix_y = int(np.floor(np.sqrt(len(self.qy_data))))
+    npix_x = int(np.floor(len(self.qy_data) / npix_y))
+
+    # bin size: x- & y-directions
+    xstep = x_size / (npix_x - 1)
+    ystep = y_size / (npix_y - 1)
+
+    # max and min taking account of the bin sizes
+    xmax = xmax + xstep / 2.0
+    xmin = xmin - xstep / 2.0
+    ymax = ymax + ystep / 2.0
+    ymin = ymin - ystep / 2.0
+
+    # store x and y bin centers in q space
+    x_bins = np.linspace(xmin, xmax, npix_x)
+    y_bins = np.linspace(ymin, ymax, npix_y)
+
+    return x_bins, y_bins
+
+def _fillup_pixels(image=None, weights=None):
+    """
+    Fill z values of the empty cells of 2d image matrix
+    with the average over up-to next nearest neighbor points
+
+    :param image: (2d matrix with some zi = None)
+
+    :return: image (2d array )
+
+    :TODO: Find better way to do for-loop below
+
+    """
+    # No image matrix given
+    if image is None or np.ndim(image) != 2 \
+            or np.isfinite(image).all() \
+            or weights is None:
+        return image
+    # Get bin size in y and x directions
+    len_y = len(image)
+    len_x = len(image[1])
+    temp_image = np.zeros([len_y, len_x])
+    weit = np.zeros([len_y, len_x])
+    # do for-loop for all pixels
+    for n_y in range(len(image)):
+        for n_x in range(len(image[1])):
+            # find only null pixels
+            if weights[n_y][n_x] > 0 or np.isfinite(image[n_y][n_x]):
+                continue
+            else:
+                # find 4 nearest neighbors
+                # check where or not it is at the corner
+                if n_y != 0 and np.isfinite(image[n_y - 1][n_x]):
+                    temp_image[n_y][n_x] += image[n_y - 1][n_x]
+                    weit[n_y][n_x] += 1
+                if n_x != 0 and np.isfinite(image[n_y][n_x - 1]):
+                    temp_image[n_y][n_x] += image[n_y][n_x - 1]
+                    weit[n_y][n_x] += 1
+                if n_y != len_y - 1 and np.isfinite(image[n_y + 1][n_x]):
+                    temp_image[n_y][n_x] += image[n_y + 1][n_x]
+                    weit[n_y][n_x] += 1
+                if n_x != len_x - 1 and np.isfinite(image[n_y][n_x + 1]):
+                    temp_image[n_y][n_x] += image[n_y][n_x + 1]
+                    weit[n_y][n_x] += 1
+                # go 4 next nearest neighbors when no non-zero
+                # neighbor exists
+                if n_y != 0 and n_x != 0 and \
+                        np.isfinite(image[n_y - 1][n_x - 1]):
+                    temp_image[n_y][n_x] += image[n_y - 1][n_x - 1]
+                    weit[n_y][n_x] += 1
+                if n_y != len_y - 1 and n_x != 0 and \
+                        np.isfinite(image[n_y + 1][n_x - 1]):
+                    temp_image[n_y][n_x] += image[n_y + 1][n_x - 1]
+                    weit[n_y][n_x] += 1
+                if n_y != len_y and n_x != len_x - 1 and \
+                        np.isfinite(image[n_y - 1][n_x + 1]):
+                    temp_image[n_y][n_x] += image[n_y - 1][n_x + 1]
+                    weit[n_y][n_x] += 1
+                if n_y != len_y - 1 and n_x != len_x - 1 and \
+                        np.isfinite(image[n_y + 1][n_x + 1]):
+                    temp_image[n_y][n_x] += image[n_y + 1][n_x + 1]
+                    weit[n_y][n_x] += 1
+
+    # get it normalized
+    ind = (weit > 0)
+    image[ind] = temp_image[ind] / weit[ind]
+
+    return image
+
+
 def demo():
     # type: () -> None
Index: sasmodels/details.py
===================================================================
--- sasmodels/details.py	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/details.py	(revision 885753a925cb7e3423bdd0db6db395557a6fb1c6)
@@ -243,5 +243,5 @@
     offset = np.cumsum(np.hstack((0, length)))
     call_details = make_details(kernel.info, length, offset[:-1], offset[-1])
-    # Pad value array to a 32 value boundaryd
+    # Pad value array to a 32 value boundary
     data_len = nvalues + 2*sum(len(v) for v in dispersity)
     extra = (32 - data_len%32)%32
@@ -250,4 +250,5 @@
     is_magnetic = convert_magnetism(kernel.info.parameters, data)
     #call_details.show()
+    #print("data", data)
     return call_details, data, is_magnetic
 
@@ -296,11 +297,10 @@
     mag = values[parameters.nvalues-3*parameters.nmagnetic:parameters.nvalues]
     mag = mag.reshape(-1, 3)
-    scale = mag[:, 0]
-    if np.any(scale):
+    if np.any(mag[:, 0] != 0.0):
+        M0 = mag[:, 0].copy()
         theta, phi = radians(mag[:, 1]), radians(mag[:, 2])
-        cos_theta = cos(theta)
-        mag[:, 0] = scale*cos_theta*cos(phi)  # mx
-        mag[:, 1] = scale*sin(theta)  # my
-        mag[:, 2] = -scale*cos_theta*sin(phi)  # mz
+        mag[:, 0] = +M0*cos(theta)*cos(phi)  # mx
+        mag[:, 1] = +M0*sin(theta) # my
+        mag[:, 2] = -M0*cos(theta)*sin(phi)  # mz
         return True
     else:
Index: sasmodels/direct_model.py
===================================================================
--- sasmodels/direct_model.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/direct_model.py	(revision d18d6ddf640c8cff5c76cfac900c1940989612ca)
@@ -345,4 +345,9 @@
             self._kernel = self._model.make_kernel(self._kernel_inputs)
 
+        # Need to pull background out of resolution for multiple scattering
+        background = pars.get('background', 0.)
+        pars = pars.copy()
+        pars['background'] = 0.
+
         Iq_calc = call_kernel(self._kernel, pars, cutoff=cutoff)
         # Storing the calculated Iq values so that they can be plotted.
@@ -357,5 +362,5 @@
                 np.reshape(Iq_calc, (self.resolution.ny, self.resolution.nx))
             )
-        return result
+        return result + background
 
 
Index: sasmodels/generate.py
===================================================================
--- sasmodels/generate.py	(revision 108e70e22154db937a6d46f66be6dd70408cce6d)
+++ sasmodels/generate.py	(revision d86f0fc0fff835c5ddf398e64c046518fa4536fc)
@@ -169,5 +169,6 @@
 
 import sys
-from os.path import abspath, dirname, join as joinpath, exists, getmtime
+from os import environ
+from os.path import abspath, dirname, join as joinpath, exists, getmtime, sep
 import re
 import string
@@ -214,5 +215,5 @@
 
 EXTERNAL_DIR = 'sasmodels-data'
-DATA_PATH = get_data_path(EXTERNAL_DIR, 'kernel_template.c')
+DATA_PATH = get_data_path(EXTERNAL_DIR, 'kernel_iq.c')
 MODEL_PATH = joinpath(DATA_PATH, 'models')
 
@@ -289,12 +290,11 @@
     import loops.
     """
-    if (info.source and any(lib.startswith('lib/gauss') for lib in info.source)):
-        import os.path
+    if info.source and any(lib.startswith('lib/gauss') for lib in info.source):
         from .gengauss import gengauss
-        path = os.path.join(MODEL_PATH, "lib", "gauss%d.c"%n)
-        if not os.path.exists(path):
+        path = joinpath(MODEL_PATH, "lib", "gauss%d.c"%n)
+        if not exists(path):
             gengauss(n, path)
         info.source = ["lib/gauss%d.c"%n if lib.startswith('lib/gauss')
-                        else lib for lib in info.source]
+                       else lib for lib in info.source]
 
 def format_units(units):
@@ -320,10 +320,10 @@
                      for w, h in zip(column_widths, PARTABLE_HEADERS)]
 
-    sep = " ".join("="*w for w in column_widths)
+    underbar = " ".join("="*w for w in column_widths)
     lines = [
-        sep,
+        underbar,
         " ".join("%-*s" % (w, h)
                  for w, h in zip(column_widths, PARTABLE_HEADERS)),
-        sep,
+        underbar,
         ]
     for p in pars:
@@ -334,5 +334,5 @@
             "%*g" % (column_widths[3], p.default),
             ]))
-    lines.append(sep)
+    lines.append(underbar)
     return "\n".join(lines)
 
@@ -389,5 +389,5 @@
     # TODO: fails DRY; templates appear two places.
     model_templates = [joinpath(DATA_PATH, filename)
-                       for filename in ('kernel_header.c', 'kernel_iq.cl')]
+                       for filename in ('kernel_header.c', 'kernel_iq.c')]
     source_files = (model_sources(model_info)
                     + model_templates
@@ -612,6 +612,6 @@
     """
     spaces = " "*depth
-    sep = "\n" + spaces
-    return spaces + sep.join(s.split("\n"))
+    interline_separator = "\n" + spaces
+    return spaces + interline_separator.join(s.split("\n"))
 
 
@@ -619,4 +619,7 @@
 def load_template(filename):
     # type: (str) -> str
+    """
+    Load template file from sasmodels resource directory.
+    """
     path = joinpath(DATA_PATH, filename)
     mtime = getmtime(path)
@@ -900,7 +903,17 @@
         kernel_module = load_custom_kernel_module(model_name)
     else:
-        from sasmodels import models
-        __import__('sasmodels.models.'+model_name)
-        kernel_module = getattr(models, model_name, None)
+        try:
+            from sasmodels import models
+            __import__('sasmodels.models.'+model_name)
+            kernel_module = getattr(models, model_name, None)
+        except ImportError:
+            # If the model isn't a built in model, try the plugin directory
+            plugin_path = environ.get('SAS_MODELPATH', None)
+            if plugin_path is not None:
+                file_name = model_name.split(sep)[-1]
+                model_name = plugin_path + sep + file_name + ".py"
+                kernel_module = load_custom_kernel_module(model_name)
+            else:
+                raise
     return kernel_module
 
